
#define EINBUFSIZE 511
#define EOUTBUFSIZE 511

#define MAX_HOST_TEMPLATES 1

char buffer[380];

struct stTemplate{
	char bloque_one[220];
   char bloque_two[140];
}templates[MAX_HOST_TEMPLATES];

int getid( int lim);

void SendCmd(char cmd, char param, int templateId)
{
	char trama[9];
	serEwrFlush();

	//Parte del head + comando y parmetro
	trama[0]=0x02;
	trama[2]=0x01;
	trama[4]=cmd;
	trama[5]=param;

   switch(cmd)
   {  //Head restante para comandos de upload
   	case  0x53: case 0x52:
   		trama[1]=(cmd==0x53)? 0xE0: 0xDF ;
   		trama[3]=(cmd==0x53)? 0xDE: 0xDD ;
	   		serEwrite(trama, ((cmd==0x53)? 6: 5) );
         		serEwrite(templates[templateId].bloque_one,220);
      //Formato adicional para comandos de upload
   		trama[0]=0x02;
   		trama[1]=0x8E;
   		trama[2]=0x02;
   		trama[3]=0x8C;
	  			serEwrite(trama,4);
         		serEwrite(templates[templateId].bloque_two,140);
         break;
      default:
      	//Head restante para mayora de los comandos
			trama[1]=0x04;
			trama[3]=0x02;
	         serEwrite(trama,6);
        	break;
	}
   //Terminador
	trama[0]=0x02;
	trama[1]=0x01;
	trama[2]=0x03;
		serEwrite(trama,3);
}

cofunc int GetResponse(char *buffer, int len)
{
	int n;
   serErdFlush();

   wfd n=cof_serEread(buffer, len,4000);
   buffer[n]=0;
   printf("\nLongitud de trama: %d\n",n);
   for(n=0;n<len;n++)
		printf("%0X ", buffer[n]);

   return n;
}




main()
{
	int c,n, templateId;
   char id, level;
   serEopen(9600);
	while(1){
		costate{

        	puts("\n\nIndique su opcion:\n");
         puts("\t1-Enroll ID\n");
         puts("\t2-Aunthenticate ID\n");
         puts("\t3-Erase Fingerprint\n");
         puts("\t4-Clear fingerprint\n");
         puts("\t5-Clear all fingerprint\n");
      	puts("\t6-Download fingerprint from flash\n");
         puts("\t7-Capture and download fingerprint from SRAM\n");
		   puts("\t8-Verification: capture, upload fingerprint and verify it\n");
      	puts("\t9-Upload fingerprint and save it into flash \n");
      	puts("\t0-Change security level\n");
		   puts("\tq-Quit\n");

          	switch( ( c=getchar()) )
            {
            	case '1'://Enroll ID
               	puts("\n\Ingrese el ID para la huella...\n");
               	if( (id=(char)getid(4))<1 || id>200 ){
                  	puts("Error, ID no vlido");
                  	break;
                  }
                  printf("\n\nEsperando huella para enrolar en flash (slot %d)",id);

                  waitfor(!BitRdPortI(PEDR,1));
                  SendCmd( 0x21, id, 0 );
                  wfd n=GetResponse(buffer, 18 );

                  if (buffer[14]==id && buffer[13]== 0x21 && n==18 )
			           	printf("\nEnrollment sucessful! ID= %d\n", buffer[14] );
                  else
                     puts("\nEnrollment fail\n");
				      break;

             	case '2'://Aunthenticate ID
				      puts("\n\nEsperando huella... \n");

                  waitfor(!BitRdPortI(PEDR,1));
                  SendCmd(0x24, 0xff, 0 );
                  wfd n=GetResponse(buffer, 18 );

                  if (buffer[14]!=0xff && buffer[13]== 0x24 && n==18 )
			           	printf("\nHuella identificada ID = %d\n", buffer[14]);
                  else
                     puts("\nLa huella no est registrada\n");

      		     	break;
             	case '3'://Erase Fingerprint
                  puts("\n\nEsperando huella para borrar...");

                  waitfor(!BitRdPortI(PEDR,1));
			         SendCmd(0x22, id, 0 );
                  wfd n=GetResponse(buffer,18);

                  if (buffer[14]!=0xff && buffer[13]== 0x22 && n==18 )
			           	printf("\nID erasing sucessful! ID= %d\n", buffer[14] );
                  else
                     puts("\nID erasing fail\n");
				      break;
             	case '4'://Clear fingerprint
               	puts("\n\Que id quiere borrar?\n");
               	if( (id=(char)getid(4))<1 || id>200 ){
                  	puts("Error, id no vlido");
                  	break;
                  }
				      printf("\n\nBorrando id %d\n", id);
				      SendCmd(0xA2, id, 0 );
                  wfd n=GetResponse(buffer, 9 );

	               if (buffer[5]== id && buffer[4]!= 0xA2 && n==9 )
			           	printf("\nClear fingerprint %d sucessful\n",id);
                  else
                     printf("\nClear fingerprint %d fail\n",id);
      		     	break;
             	case '5'://Clear all fingerprint
				      puts("\n\nBorrando todo... \n");
				      SendCmd(0xA6, 0xff, 0 );
                  wfd n=GetResponse(buffer, 9 );

                  if (buffer[5]==0xD1 && buffer[4]!= 0xA6 && n==9 )
			           	puts("\nClear all fingerprints sucessful\n");
                  else
                     puts("\nClear fail\n");
      		     	break;
             	case '6': //Download fingerprint
               	puts("\n\Que id quiere descargar?\n");
               	if( (id=(char)getid(4))<1 || id>200 ){
                  	puts("Error, id no vlido");
                  	break;
                  }
				      printf("\n\nDescargando id %d\n", id);
  				      SendCmd(0xA4, id, 0 );
                  wfd n=GetResponse(buffer, 370 );

                  if (	buffer[366]== 0x55 && buffer[367]== 0xAA &&
                  		buffer[368]== 0x55 && buffer[369]== 0xAA  && n==370){
			           			printf("\nDownload fingerprint template %d sucessful\n",id);
                  			//y guardo el template
                           puts("\n\Ingrese el ID para almacenar el template...\n");
				               	if( (templateId=(char)getid(4))<0 || templateId>MAX_HOST_TEMPLATES-1 ){
            				      	puts("Error, ID no vlido.\nSe utilizar la posicin 0");
                  					templateId=0;
				                  }
			                 	memcpy(templates[templateId].bloque_one, &buffer[2],220);
                          	memcpy(templates[templateId].bloque_two, &buffer[224],140);
                  }
                  else
                     printf("\nDownload fingerprint template %d fail\n",id);
      		     	break;
               case '7'://Download fingerprint from SRAM 0x50 + 0x51
  						//Captura (cmd 0x50)
                  puts("\nCapturando huella\n");
                  waitfor(!BitRdPortI(PEDR,1));
  				      SendCmd(0x50, 0xff, 0 );
                  wfd n=GetResponse(buffer, 18 );

                  if (buffer[14]==0x01 && buffer[13]== 0x50 && n==18 )
			           	puts("\nHuella capturada\n");
                  else{
                     puts("\nError. La huella no fue capturada\n");
	      		     	break;
                  }
                  //Descarga de template
                  puts("\n\nDescargando template\n");
                  waitfor(DelayMs(1000));
  				      SendCmd(0x51, 0xff, 0 );
                  wfd n=GetResponse(buffer, 374 );

                  if (	buffer[370]== 0x02 && buffer[371]== 0x02 &&
                  		buffer[372]== 0x06 && buffer[373]== 0x00 ){
			           			printf("\nDownload fingerprint template sucessful\n");
                          //y guardo el template
                           puts("\nIngrese el ID para almacenar el template en el host\n");
                           printf("La cantidad mxima de templatesd es de %d\n",MAX_HOST_TEMPLATES);
                           printf("\nElija un nmero de 0 a %d\n",MAX_HOST_TEMPLATES-1);
				               	if( (templateId=(char)getid(4)<0) || templateId>(MAX_HOST_TEMPLATES-1) ){
            				      	puts("Error, ID no vlido.\nSe utilizar la posicin 0");
                  					templateId=0;
				                  }
       			            memcpy(templates[templateId].bloque_one, &buffer[6],220);
                          	memcpy(templates[templateId].bloque_two, &buffer[230],140);
                           puts("\nEl template ha sido guardado en el host\n");
                        }
                  else
                     printf("\nDownload fingerprint template fail\n");

      		     	break;
					case '8':
               	//Verification: capture fingerprint, then upload template
                 	//finally verify that them match (cmd 0x50 + 0x53)
  						//Captura
                  puts("\n\Ingrese el ID del template almacenado en el host...\n");
               	if( (templateId=(char)getid(4))<0 || templateId>MAX_HOST_TEMPLATES-1 ){
                  	puts("Error, ID no vlido");
                  	break;
                  }
                  puts("\nEsperando huella...\n");
                  waitfor(!BitRdPortI(PEDR,1));
  				      SendCmd(0x50, 0xff, 0 );
                  wfd n=GetResponse(buffer, 18 );

                  if (buffer[14]==0x01 && buffer[13]== 0x50 && n==18 )
			           	puts("\nHuella capturada\n");
                  else{
                     puts("\nError. La huella no fue capturada\n");
	      		     	break;
                  }
                  //Upload del template  (cmd 0x53)
                  //Los datos deben estar previamente guardados por la
                  //opcin 7.
                  printf("\n\nEnviando template %d\n", templateId);

  				      SendCmd(0x53, 0xff, templateId );
                  wfd n=GetResponse(buffer, 9);

  			         for(c=0;c<9;c++)
	      			   printf("%0X-", buffer[c]);
                  //Verificacin
                  puts("\n\nVerificando\n");
                  if (	buffer[4]== 0x53 && buffer[5]== 0x00 )
			           	printf("\nFingerprint vs template %d verification sucessful\n",templateId);
                  else
                     printf("\nFingerprint vs template %d verification failure\n",templateId);

      		     	break;
               case '9':
               	//Upload fingerprint into SRAM and Wwrite it into flash
                  //Upload del template  (cmd 0x52 + 0xA1)
                  //El template deben estar previamente guardados mediante la
                  //opcin 7 )

                  puts("\n\Ingrese el ID del template almacenado en el host...\n");
               	if( (templateId=(char)getid(4))<0 || templateId>MAX_HOST_TEMPLATES-1 ){
                  	puts("Error, ID no vlido");
                  	break;
                  }
                  puts("\n\nEnviando template\n");
  				      SendCmd(0x52, id, templateId );
                  wfd n=GetResponse(buffer, 9);

                  //Verificacin
                  if (	buffer[4] == 0x52 && buffer[5]== 0x01 )
			           	puts("\nFingerprint upload sucessful\n");
                  else{
                     puts("\nFingerprint upload failure\n");
                     break;
                  }
                  puts("\n\Ingrese el ID...\n");
               	if( (id=(char)getid(4))<1 || id>200 ){
                  	puts("Error, ID no vlido");
                  	break;
                  }
 				      printf("\n\nGrabando ID %d en flash\n", id);
  				      SendCmd(0xA1, id, 0 );
                  wfd n=GetResponse(buffer, 9);

	               if (buffer[4]== 0x21 && buffer[5]== id && n==9 )
			           	printf("\nSave fingerprint in slot %d sucessful\n",id);
                  else
                     printf("\nSave fingerprint in slot %d failure\n",id);

               	break;
            	case '0'://Change security level
               	puts("\nIngrese el nivel de seguridad: 01.Low\t02.Normal\t03.High\n");
               	if( (level=(char)getid(3))<1 || level>3 ){
                  	puts("Error, nivel no vlido");
                  	break;
                  }
                  level= (level+1) * 16;
                  SendCmd( 0xA5, level , 0 );
                  wfd n=GetResponse(buffer, 9 );

	               if (buffer[4]== 0xA5 && buffer[5]== level && n==9 )
			           	printf("\nSave security level in %d sucessful\n",buffer[5]);
                  else
                     printf("\nSave security level in %d failure\n",buffer[5]);
				      break;
	            case 'q':
	            	exit(0);
           }
		}
   }
}

/* getline: read a line into return line converted to int */
int getid( int lim)
{
	int c, i;
   char s[4];
	for (i=0; i < lim-1 && (c=getchar())!=EOF && c!='\n'; ++i)
   {
		if ( (!isdigit(c)) )
       return -1;
       putchar( (s[i]= c));
   }
	return atoi(s);
}